-----------------------------------------------------------------------------
--             ZEN TIMER  V2.21 (IMPROOVED AND OPTIMIZED VERSION)          --
--       FROM THE BOOK "ZEN OF ASSEMBLY LANGUAGE" VOLUME 1, KNOWLEDGE      --
--                           BY MICHAEL ABRASH                             --
--                                                                         --
--        C/C++ MODIFICATIONS BY KENDALL BENNETT, SciTech Soft 1996        --
--           TMT PASCAL VERSION BY VADIM BODROV, TMT Corp 1997,98          --
-----------------------------------------------------------------------------

 unit ZenTimer;

 interface

 procedure LZTimerOn;
 function  LZTimerLap: DWord;
 procedure LZTimerOff;
 function  LZTimerCount: DWord;
 procedure LZDelay (Value: DWord);

 implementation

 var
  StartBIOSCount,EndBIOSCount: DWord;
  EndTimedCount:               Word;

 procedure LZTimerOn; assembler;
      asm
        mov     al,$34
        out     $43,al
        db      $EB,$00,$EB,$00,$EB,$00
        xor     ax,ax
        out     $40,al
        db      $EB,$00,$EB,$00,$EB,$00
        out     $40,al
        cli
        mov     edi,$46C
        add     edi,[_zero]
        mov     eax,dword ptr [edi]
        sti
        mov     dword ptr [StartBIOSCount],eax
        mov     al,$34
        out     $43,al
        db      $EB,$00,$EB,$00,$EB,$00
        xor     ax,ax
        out     $40,al
        db      $EB,$00,$EB,$00,$EB,$00
        out     $40,al
 end;

 procedure LZTimerOff; assembler;
      asm
        xor     al,al
        out     $43,al
        cli
        mov     edi,$46C
        add     edi,[_zero]
        mov     eax,dword ptr [edi]
        mov     dword ptr [EndBIOSCount],eax
        in      al,$40
        db      $EB,$00,$EB,$00,$EB,$00
        mov     ah,al
        in      al,$40
        xchg    ah,al
        neg     ax
        mov     [EndTimedCount],ax
        sti
 end;

 function  LZTimerLap: DWord; assembler;
      asm
        xor     al,al
        out     $43,al
        cli
        mov     edi,$46C
        add     edi,[_zero]
        mov     eax,dword ptr [edi]
        mov     dword ptr [EndBIOSCount],eax
        in      al,$40
        db      $EB,$00,$EB,$00,$EB,$00
        mov     ah,al
        in      al,$40
        xchg    ah,al
        neg     ax
        mov     [EndTimedCount],ax
        sti
        mov     eax,dword ptr [EndBIOSCount]
        cmp     eax,dword ptr [StartBIOSCount]
        jae     @CalcBIOSTime
        add     dword ptr [EndBIOSCount],$001800B0
@CalcBIOSTime:
        mov     eax,[EndBIOSCount]
        sub     eax,[StartBIOSCount]
        mov     edx,54925
        mul     edx
        mov     ebx,eax
        movzx   eax,[EndTimedCount]
        mov     esi,8381
        mul     esi
        mov     esi,10000
        div     esi
        add     eax,ebx
 end;

 function  LZTimerCount: DWord; assembler;
      asm
        mov     eax,dword ptr [EndBIOSCount]
        cmp     eax,dword ptr [StartBIOSCount]
        jae     @CheckForHour
        add     dword ptr [EndBIOSCount],$001800B0
@CheckForHour:
        mov     ax,word ptr [StartBIOSCount+2]
        cmp     ax,word ptr [EndBIOSCount+2]
        je      @CalcBIOSTime
        inc     ax
        cmp     ax,word ptr [EndBIOSCount+2]
        jne     @TestTooLong
        mov     ax,word ptr [EndBIOSCount]
        cmp     ax,word ptr [StartBIOSCount]
        jb      @CalcBIOSTime
@TestTooLong:
        mov     eax,$FFFFFFFF
        ret
@CalcBIOSTime:
        mov     eax,[EndBIOSCount]
        sub     eax,[StartBIOSCount]
        mov     edx,54925
        mul     edx
        mov     ebx,eax
        movzx   eax,[EndTimedCount]
        mov     esi,8381
        mul     esi
        mov     esi,10000
        div     esi
        add     eax,ebx
 end;

 procedure LZDelay(Value: DWord);
 var CurValue: LongInt;
 begin
  CurValue:=LZTimerLap+Value;
  while LZTimerLap<CurValue do
 end;

 end.
